@echo off
pushd %~d0%~p0

setlocal EnableDelayedExpansion

set "_READERNAME=READER"
set "_READERMODEL=PRS-T2"

for /F "usebackq tokens=1" %%a in (`.\ebook_msc.exe name "%_READERMODEL%/2001" getdrv`) do (
   if /I "%%a" NEQ "NONE" (
	  set "DRIVE=%%a"
	  set "FILESFX=us"
	  goto :done_looking
   )
)

for /F "usebackq tokens=1" %%a in (`.\ebook_msc.exe name "%_READERMODEL%/2007" getdrv`) do (
   if /I "%%a" NEQ "NONE" (
	  set "DRIVE=%%a"
	  set "FILESFX=ru"
	  goto :done_looking
   )
)

for /F "usebackq tokens=1" %%a in (`.\ebook_msc.exe name "%_READERMODEL%/2044" getdrv`) do (
   if /I "%%a" NEQ "NONE" (
	  set "DRIVE=%%a"
	  set "FILESFX=eu"
	  goto :done_looking
   )
)

echo Reader [%_READERNAME%] not found
echo.
.\ebook_msc.exe listdrv
echo.
set /p DRIVE="Enter the letter of the Reader drive? "
if errorlevel 1 goto :failure

:done_looking

set "DRIVE=%DRIVE:~0,1%"
vol %DRIVE%:
if errorlevel 1 goto :failure

set /p "ANSWER=Continue? <Y/N> "

if /I "%ANSWER%" NEQ "Y" goto :failure

for /F "usebackq skip=12 tokens=3" %%a in (`.\ebook_msc.exe name "%_READERMODEL%" info`) do (
   if /I "%%a" NEQ "1.0.04.11081" if /I "%%a" NEQ "1.0.01.11080" (
       echo Device has unsupported firmware version %%a
       goto :failure
   )
   echo Device has supported firmware version %%a
   goto :continue
)

:continue

if exist %DRIVE%:\updates rmdir %DRIVE%:\updates /Q /S

if not exist ./sdcard goto :nocopy-sdcard

xcopy .\sdcard\*.* %DRIVE%:\ /E /C /R /H /I /K /Y 
if errorlevel 1 goto :failure

:nocopy-sdcard

if exist %DRIVE%:\"%_READERMODEL% Updater.package" del %DRIVE%:\"%_READERMODEL% Updater.package"

xcopy ".\%_READERMODEL% Updater.package-%FILESFX%" %DRIVE%:\ /Y
if errorlevel 1 goto :failure

ren %DRIVE%:\"%_READERMODEL% Updater.package-%FILESFX%" "%_READERMODEL% Updater.package"
if errorlevel 1 goto :failure

.\ebook_msc.exe name %_READERMODEL% um recovery
if errorlevel 1 goto :failure

pause
popd 
goto :eof

:failure
echo Script did not complete
pause
popd 

